//"diag_bp.sc","51bp : diagnostyka bufora pozycji handlowych",12004,0,1.0.1,SYSTEM
//"Diagnostyka",12001,14,16
////////////////////////////
////////////////////////////
// 51bp : diagnostyka bufora pozycji handlowych
// diag_bp.sc
////////////////////////////
// Napisa: Sebastian Nowak
// data:    98.07.15

#define NAZWA_PLIKU "DIAG_BP.TXT"

#define KZS		109		//Kontrakt zaliczkowy
#define ZSK		122		//Kontrakt zaliczkowy korekta
#define KZZ		111		//Kontrakt zaliczkowy zakupu
#define ZZK		123		//Kontrakt zaliczkowy zakupu korekta

string sRaportDescription

#include "Diagnostyka - funkcje"
UsunRekord_0("BP")

sDialogTitle += "pozycji bufora pozycji handlowych"

StageAddDesc("Raport porwnuje sum wartoci NETTO oraz VAT z pozycji dokumentw w")
StageAddDesc("buforze z wartociami zapisanymi w dokumentach w buforze oraz wywietla")
StageAddDesc("nazwy niepoprawnych dokumentw. Ponadto usuwane s rekordy dugich nazw")
StageAddDesc("z bazy notatek NT ktre odwouj si do nieistniejcych pozycji w buforze")
StageAddDesc("dokumentw handlowych")
StageAddStage("Porwnanie sumy pozycji z dokumentem")
if (firma.code == "HM") || (firma.code == "HL") then
	StageAddStage("Sprawdzenie rezerwacji")
else
	StageAddStage("X")
endif
StageAddStage("Sprawdzenie dugich nazw")

StageAddStage("Sprawdzenie iloci pozostaej do rozliczenia")

ChooseStages( 400 )


int bd,bp, bp2, dp, zz1
BaseAll nt
BaseAll nt2
int typ
float vat,netto
long id
BaseZZ zz

dp=OpenBase("dp")	
bp=OpenBase("bp")
bp2=OpenBase("bp")
bd=OpenBase("bd")
zz1=OpenBase("zz")
OpenBaseB(nt,"NT")
OpenBaseB(nt2,"NT")

//---------------------------------------------------------------------------------------------
// zwraca sum pozycji z dokumentw
Float Sub SumaPozHandl(long idBP)
	int err
	
	SetKey(dp,"idhandl")
	SetKeySeg(dp,"idhandl",idBP)
	SetKeySeg(dp,"data","0000-00-00")
	err=GetRec(dp,GE)

	While !err && GetKeySeg(dp,"idhandl") == idBP
		SumaPozHandl += GetField(dp, "ilosc")
		err=GetRec(dp,NX)
	Wend
EndSub

//---------------------------------------------------------------------------------------------

Int Sub PrzylaczPozZamowienia(long idBP, long idBD, long idTW)
	int err, err1
	long idDK

long test	

	// szukam poczenie BD --* ZZ *-- DK
	SetKey(zz1, "cross1")
	SetKeySeg(zz1, "typi", 144)	// 144	dokument handlowy, ID1 - id zamowienia
	SetKeySeg(zz1, "baza1", 28)
	SetKeySeg(zz1, "id1", idBD)
	SetKeySeg(zz1, "baza2", 16)
	SetKeySeg(zz1, "id2", 0)
	err=GetRec(zz1,GT)
	While !err && GetKeySeg(zz1,"id1") == idBD
		idDK = GetKeySeg(zz1,"id2")

		SetKey(dp,"super")
		SetKeySeg(dp,"super",idDK)
		SetKeySeg(dp,"lp",0)
		err1=GetRec(dp,GE)
		While !err1 && GetKeySeg(dp,"super") == idDK
			If GetField(dp,"idtw") == idTW && GetField(dp, "idhandl") != idBP Then
				SetKey(bp2, "id")
				SetKeySeg(bp2, "id", GetField(dp, "idhandl"))

				if GetRec(bp2, EQ) || GetField(bp2, "super") != idBD || GetField(bp2, "idtw") != idTW then
				      if TextOutAndAsk3(15,(using "Pozycja handlowa '%s' id=%l wskazuje na niewaciw pozycj zamwienia idhandl=%l", GetField(dp, "kod"),GetField(dp,"id"),GetField(dp,"idhandl"))) then
							SetField(dp,"idhandl", idBP)
		 	 				UpdateRec(dp,"DP")
					  else
						TextOut(sNoRepair)
					  endif
				endif
			EndIf
			err1=GetRec(dp,NX)
		Wend

		err=GetRec(zz1,NX)
	Wend
EndSub

//---------------------------------------------------------------------------------------------

TextOut("Podsumowanie sprawdzania poprawnoci bazy bufora pozycji handlowych\n\n")

WriteStatusBar("Sprawdzanie pozycji dokumentw w buforze")
PopUp(1,"Sprawdzanie pozycji dokumentu:")

SetKey(bd,"id")
SetKey(bp,"super")
err=GetRec(bd,FS)
if !StageT(1) then err=1

while !err
	typ=GetField(bd,"typi")

	if !typ || typ==201 || typ==202 || typ==100 || typ==111 || typ==112 then

		// naliczenie netto i vat

		PopUp(2,GetField(bd,"kod"))
		id=GetKeySeg(bd,"id")
		SetKeySeg(bp,"super",id)
		SetKeySeg(bp,"lp",0)
		netto=vat=0
		err=GetRec(bp,GE)
		while !err && GetKeySeg(bp,"super")==id
			if GetField(bp,"typi")!=1 && !(GetField(bp,"flag")&0x4000) then				// 1=komplet lub anulowana
				netto+=GetField(bp,"wartNetto")
				vat+=GetField(bp,"wartVat")
			endif
			if GetField(bp,"subtypi")!=GetField(bd,"typi") then
				if TextOutAndAsk3(8,using "Pozycja '%s' id=%l dokumentu '%s' ma subtyp niezgodny z typem dokumentu",GetField(bp,"kod"),GetField(bp,"id"),GetField(bd,"kod")) then
					SetField(bp,"subtypi",GetField(bd,"typi"))
			  	 	UpdateRec(bp,"BP")
				else
					TextOut(sNoRepair)
				endif
			endif
			err=GetRec(bp,NX)
		wend
		if Sign(GetField(bd,"netto")-netto,2) || (Sign(GetField(bd,"vat")-vat,2) && GetField(bd,"subtypi")!=46)then
			TextOut("Nie zgadza si warto ")
			// VAT nie sprawdzany gdy DEX czyli subtyp=46
			if Sign(GetField(bd,"netto")-netto,2) && Sign(GetField(bd,"vat")-vat,2) && GetField(bd,"subtypi")!=46 then
				TextOut("NETTO oraz VAT")
			else
				if Sign(GetField(bd,"netto")-netto,2) then TextOut("NETTO")
				if Sign(GetField(bd,"vat")-vat,2) && GetField(bd,"subtypi")!=46 then TextOut("VAT")
			endif
			TextOut(using " w dokumencie '%s'\n",GetField(bd,"kod"))
		endif		
	endif

	err=GetRec(bd,NX)
wend

StageSummary(1)


// sprawdzanie poprawnoci pl: rezerwacja, realizacja

SetKey(bp,"id")
err=GetRec(bp,FS)
progress.Reset(GetRecordCount(bp))
if !StageT(2) then err=1
while !err
	if ((firma.code == "HM") || (firma.code == "HL")) && GetField(bp,"rezerwacja") then
		if zz.GetRecById(GetField(bp,"rezerwacja")) || zz.GetField("typi")!=96 || zz.GetField("baza3")!=28 || zz.GetField("id3pos")!=GetField(bp,"id") then
			if TextOutAndAsk3(1,using "Pozycja '%s' id=%l wskazuje na nieprawidow rezerwacje",GetField(bp,"kod"),GetField(bp,"id")) then
				SetField(bp,"rezerwacja",0)
				UpdateRec(bp,"BD")
			else
				TextOut(sNoRepair)
			endif
		endif
	endif
		
	if ((firma.code == "HM") || (firma.code == "HL")) && GetField(bp,"realizacja") then
		if zz.GetRecById(GetField(bp,"realizacja")) || (zz.GetField("typi")!=96 && zz.GetField("typi")!=98) then
			if TextOutAndAsk3(1,using "Pozycja '%s' id=%l wskazuje na nieprawidow realizacje",GetField(bp,"kod"),GetField(bp,"id")) then
				SetField(bp,"realizacja",0)
				UpdateRec(bp,"BD")
			else
				TextOut(sNoRepair)
			endif
		endif
	endif
		
	err=GetRec(bp,NX)
wend

StageSummary(2)


if StageT(3) then

PopUp(1,"Sprawdzanie notatek")
PopUp(2,"")

SetKey(bp,"id")
nt.SetKey("id")
nt2.SetKey("super")
nt2.SetKeySeg("typi",16)
nt2.SetKeySeg("baza",30)
err=GetRec(bp,FS)
progress.Reset(GetRecordCount(bp))
while !err
	progress.NextOne()
  if GetField(bp,"idlongname") then
		nt.SetKeySeg("id",GetField(bp,"idlongname"))
    if nt.GetRec(EQ) || nt.GetField("typi")!=16 || nt.GetField("baza")!= 30 || nt.GetFIeld("super")!=GetField(bp,"id") then
			nt2.SetKeySeg("super",GetField(bp,"id"))
			id = 0
			if !nt2.GetRec(EQ) then id=nt2.GetField("id")
      if TextOutAndAsk3(9,(using "Pozycja '%s' id=%l ma niewaciwie powizan dug nazw",GetField(bp,"kod"),GetField(bp,"id"))) then
	 	    SetField(bp,"idlongname",id)
  	 	  UpdateRec(bp,"BP")
			else
				TextOut(sNoRepair)
			endif
		endif
  endif
	
	err=GetRec(bp,NX)
wend

nt.SetKey("super")
nt.SetKeySeg("typi",16)
nt.SetKeySeg("baza",30)
err=nt.GetRec(GE)
while !err && nt.GetField("typi")==16 && nt.GetField("baza")==30
	SetKeySeg(bp,"id",nt.GetField("super"))
	if GetRec(bp,EQ) then
		if TextOutAndAsk3(10,(using "W bazie notatek znajduje si rekord o numerze %d odwoujcy si do nieistniejcej pozycji",nt.GetField("id"))) then
			DeleteRecB(nt)
		else
			TextOut(sNoRepair)
		endif
	else
		if GetField(bp,"idlongname")!=nt.GetField("id") then
      if TextOutAndAsk3(11,(using "Pozycja '%s' id=%l ma niewaciwie powizan dug nazw",GetField(bp,"kod"),GetField(bp,"id"))) then
				SetField(bp,"idlongname",nt.GetField("id"))
  	 	  UpdateRec(bp,"BP")
			else
				TextOut(sNoRepair)
			endif
		endif
	endif
	err=nt.GetRec(NX)
wend

StageSummary(3)

endif		// stage

//----------------------------------------------------------------------------------------------

PopUp(1,"Sprawdzanie iloci pozostaej do rozliczenia")
PopUp(2,"")

SetKey(bd,"id")
SetKey(bp,"super")
err=GetRec(bd,FS)

if !StageT(4) then err=1
float iloscdorozl,iltest
string realizacja
long idBD
int subtyp
while !err
	typ=GetField(bd,"typi")
	subtyp=GetField(bd,"subtypi")
	If (typ == 1 || typ == 203) && (subtyp != KZS && subtyp != ZSK && subtyp != KZZ && subtyp != ZZK) Then	// zamwienie obce, zamwienie wasne
		realizacja = "1"
		idBD = GetKeySeg(bd,"id")
		SetKeySeg(bp,"super", idBD)
		SetKeySeg(bp,"lp",0)
		err=GetRec(bp,GE)
		while !err && GetKeySeg(bp,"super")==idBD
			// naprawa pola 'idhandl' w bazie DP
			PrzylaczPozZamowienia(GetField(bp, "id"), idBD, GetField(bp, "idtw"))

			iloscdorozl = GetField(bp,"ilosc") - SumaPozHandl(GetField(bp, "id"))
			iltest=GetField(bp,"iloscdorozl")
			// zamwienie wasne
			If typ == 203 && sign(iltest-iloscdorozl,4) && !(!sign(iltest,4) && iloscdorozl > 0) Then
	      if TextOutAndAsk3(16,(using "Zamwienie wasne. Pozycja '%s' id=%l ma niewaciwi warto iloci do rozliczenia", GetField(bp, "kod"),GetField(bp,"id"))) then
					If 0 < iloscdorozl Then
						SetField(bp,"iloscdorozl", 0)
			 	 	  UpdateRec(bp,"BP")
					Else
						SetField(bp,"iloscdorozl", iloscdorozl)
			 	 	  UpdateRec(bp,"BP")
					EndIf
				else
					TextOut(sNoRepair)
				endif
			EndIf

			// zamwienie obce
			If typ == 1 && sign(iltest-iloscdorozl,4) && !(!sign(iltest,4) && iloscdorozl < 0) Then
	      if TextOutAndAsk3(13,(using "Zamwienie obce. Pozycja '%s' id=%l ma niewaciwi warto iloci do rozliczenia", GetField(bp, "kod"),GetField(bp,"id"))) then
					If 0 > iloscdorozl Then
						SetField(bp,"iloscdorozl", 0)
			 	 	  UpdateRec(bp,"BP")
					Else
						SetField(bp,"iloscdorozl", iloscdorozl)
			 	 	  UpdateRec(bp,"BP")
					EndIf
				else
					TextOut(sNoRepair)
				endif
			EndIf
			If sign(GetField(bp,"iloscdorozl"),4) Then realizacja = "0"
			err=GetRec(bp,NX)
		wend


		// sprawdzam pole BD.ok = 1 - zrealizowano
		If GetField(bd,"oki") != val(realizacja) Then
      if TextOutAndAsk3(14,(using "Pozycja '%s' id=%l nie jest zrealizowana", GetField(bd, "kod"),GetField(bd,"id"))) then
				SetField(bd,"oki", val(realizacja))
	 	 	  UpdateRec(bd,"BD")
			else
				TextOut(sNoRepair)
			endif
		EndIf

	EndIf
	err=GetRec(bd,NX)
wend
StageSummary(4)

TextOut("\nZakoczono.")

ShowFileInfo()

close

