//"dokengkp.sci","Engine do korekt przyj",12401,0,1.0.0,SYSTEM
//"Dokumenty magazynowe",12400,14,62
////////////////////////////
// Engine do korekt przyj
// dokengkp.sci
////////////////////////////

Limit 10000

#include "Nagwek i stopka raportu I"

record InfoPoz
	int lp
	string Opis[41]
	string Kod[40]
	string KodObcy[26]
	string Dostawa[30]
	float Ilosc
	float IloscWP
	float PrzelJMDod
	float Cena
	float CenaWP
	string Jm[9]
	string JmWP[9]
	float Wartosc
	long 		idtw
endrec

record InfoDost
	int  lp
	long id
	int   typ		// 1-pozycja przed korekt 2-korekta 3-po korekcie
	string nazwa[40]
	float ilosc
	float Cena
	float wartosc
endrec


record InfoKWM
	string kod[26]
	float przychod
	float rozchod
endrec


//record Info_KCena
//	int lp
//	long id
//	float Cena
//endrec


InfoPoz PozycjeBaza(1)
InfoPoz PozycjeKoryg(1)
InfoPoz PozycjePoKor(1)
InfoDost Dostawy(1)
//Info_KCena KorektaCeny(1)
string KodyKorekt(1)
string sKodDokHand, sDataDokHand
MapValue poz_opis
MapValue poz_opis_Tmp		// Bxx - bazowe   Kxx - korekty
long iddp
int czyNPinna=0,licznikNP=0,bNP=0,bazaLp
int NPinna(1),NPpraw(1),nWskZer,bylyPoz=0
InfoKWM korektyWM(1)		//korekty wartoci magazynowych KWM

MapValue IdNaIndex

poz_opis.Type(string)
poz_opis_Tmp.Type(string)

int nt,GRAF,BUFOR,mg,mz,err,pw,dw,dk,dp,mg2,mz2,mgb,mzb,zz,kh,uz,tw,dppom
int nPoz,i,j,k,l,nDostawy
string sMG,sMZ,sDK,sDP
long iddok,lTemp
float tot_netto,tot_nettoPrzed,tot_nettoPo
float tot_KWMprzy, tot_KWMroz, tot_KWM

// ****************************

int sub OpenBase( string bas )
	OpenBase = open KatalogFirmy() + "51" + bas + ".dat" for base bas
	BaseError(OpenBase,4)
endsub


string sub DajNIP( string NIP )
// funkcja zwraca "REGON: ","PESEL: ","NIP: "
// w zmiennej buf zwraca cig odpowiednich cyfr
	buf=NIP
	if find regular "{[rRpP]}/:{*$}" then
		Select Case regular 1
		Case "R","r"
			DajNip = "REGON: "
		Case "P","p"
			DajNip = "PESEL: "
		EndSelect
		NIP = regular 2
		buf = NIP
	else
		DajNIP="NIP: "
		buf = NIP
	endif
endsub

string sub GetName(int m)
	if GetField( m,"idlongname" ) then
		SetKey( nt,"id" )
		SetKeySeg( nt,"id",GetField( m,"idlongname" ) )
		GetRec( nt,EQ )
		BaseError( nt,4 )
		GetName = GetField( nt,"opis" )
	else
		GetName = GetField( m,"opis" )
	endif
endsub

string sub KodPaskowy_pozycji(InfoPoz poz)
	if !(Poz.idtw) then  KodPaskowy_pozycji = "" : exit
	SetKeySeg(tw,"ID",Poz.idtw)
	if GetRec(tw,EQ) then KodPaskowy_pozycji = "" : exit
	KodPaskowy_pozycji = GetField(tw,"kodpaskowy")
endsub

int sub ZbierzPozycje( InfoPoz poz, int m, int typ, int mzTyp, string prefix )
	if !poz.lp then
		poz.lp=GetField(m,"lp")
		if prefix=="K" then 
			if poz.lp>10000 then 
				czyNPinna=1
				NPinna(size(NPinna))=poz.lp
				grow NPinna,1
			endif
		endif
		poz.Opis=GetField(m,"opis")
		poz_opis.Set((using"%s%d",prefix,poz.lp),GetName(m))
		if ((firma.code == "HM") || (firma.code == "HL")) then
			SetKeySeg(uz,"iduz",GetField(m,"idtw"))
			SetKeySeg(uz,"idkh",GetField(m,"idkh"))
			if !GetRec(uz,EQ) then poz.KodObcy=GetField(uz,"kodobcy")
		endif
		poz.Kod=GetField(m,"kod")
		poz.Jm=GetField(m,"jm")	
		poz.JmWP=GetField(m,"jmWP")	
		poz.idtw = GetField ( m,"idtw" )
	endif

	poz.Ilosc+=GetField(m,"ilosc")
	poz.IloscWP+=GetField(m,"iloscWP")
	poz.wartosc+=GetField(m,"wartNetto")
	poz.Cena+=GetField(m,"cena")
	if Poz.IloscWP then Poz.PrzelJMDod=Poz.Ilosc/Poz.IloscWP
	if !Poz.PrzelJmDod then poz.PrzelJmDod=1
	poz.CenaWP=poz.Cena//poz.PrzelJMDod //bylo * zamiast /
	
	SetKeySeg(pw,"typi",mzTyp)
	SetKeySeg(pw,"idmg",GetField(m,"id"))
	SetKeySeg(pw,"iddw",0)
	err=GetRec(pw,GE)
	while !err && GetField(pw,"idmg")==GetField(m,"id") && GetField(pw,"typi")==mzTyp
		// czy ta dostawa ju jest
		for i=1 to i>nDostawy
			if dostawy(i).typ==typ && dostawy(i).lp==poz.lp && dostawy(i).id==GetField(pw,"iddw") then
				dostawy(i).ilosc+=GetField(pw,"ilosc")
				dostawy(i).wartosc+=GetField(pw,"wartosc")
				if Sign(dostawy(i).ilosc,4) && typ!=2 then Dostawy(i).cena = Dostawy(i).wartosc/Dostawy(i).ilosc
				i=nDostawy+2
			endif
		next i
		if i==nDostawy+1 then		// dodajemy now dostaw
			
			if nDostawy then grow dostawy,1
			nDostawy+=1
			dostawy(nDostawy).typ=typ
			dostawy(nDostawy).lp=poz.lp
			dostawy(nDostawy).id=GetField(pw,"iddw")
			SetKeySeg(dw,"id",GetField(pw,"iddw"))
			if !GetRec(dw,EQ) then dostawy(nDostawy).nazwa=GetField(dw,"kod")
			dostawy(nDostawy).ilosc=GetField(pw,"ilosc")
			dostawy(nDostawy).wartosc=GetField(pw,"wartosc")
			if Sign(dostawy(nDostawy).ilosc,4) && typ!=2 then Dostawy(nDostawy).cena = Dostawy(nDostawy).wartosc/Dostawy(nDostawy).ilosc
		endif
		err=GetRec(pw,NX)
	wend
endsub


int sub ZbierzRezerwacje( InfoPoz poz, int m, int typ, string prefix )
	if !poz.lp then
		poz.lp=GetField(m,"lp")
		poz.Opis=GetField(m,"opis")
		poz_opis.Set((using"%s%d",prefix,poz.lp),GetName(m))
		if ((firma.code == "HM") || (firma.code == "HL")) then
			SetKeySeg(uz,"iduz",GetField(m,"idtw"))
			SetKeySeg(uz,"idkh",GetField(m,"idkh"))
			if !GetRec(uz,EQ) then poz.KodObcy=GetField(uz,"kodobcy")
		endif
		poz.Kod=GetField(m,"kod")
		poz.Jm=GetField(m,"jm")	
		poz.JmWP=GetField(m,"jmWP")	
		poz.idtw = GetField ( m,"idtw" )
	endif

	SetKeySeg(zz,"id",GetField(m,"rezerwacja"))
	err=GetRec(zz,GE)
	if err then exit

	SetKeySeg(pw,"typi",26)
	SetKeySeg(pw,"idmg",GetField(m,"rezerwacja"))
	SetKeySeg(pw,"iddw",0)
	err = GetRec(pw,GE)
	while  !err && GetField(pw,"idmg")==GetField(m,"rezerwacja") && GetField(pw,"typi")==26
		if nDostawy then grow dostawy,1
		nDostawy+=1
		dostawy(nDostawy).typ=typ
		dostawy(nDostawy).lp=poz.lp
		dostawy(nDostawy).ilosc=GetField(pw,"ilosc")
		dostawy(nDostawy).wartosc=GetField(pw,"wartosc")
		if Sign(dostawy(nDostawy).ilosc,4) && typ!=2 then Dostawy(nDostawy).cena = Dostawy(nDostawy).wartosc/Dostawy(nDostawy).ilosc

		SetKeySeg(dw,"id",GetField(pw,"iddw"))
		if !GetRec(dw,EQ) then dostawy(nDostawy).nazwa=GetField(dw,"kod") : dostawy(nDostawy).id=GetField(dw,"id")

		err=GetRec(pw,NX)
	wend

endsub


int sub ZbierzKorekteCeny( InfoPoz poz, int typ, string prefix )
	if Sign(GetField(mzb,"cena")) && (GetField(mgb,"flag")&0x100) then

		if !poz.lp then
			poz.lp=GetField(mzb,"lp")
			poz.Opis=GetField(mzb,"opis")
			poz_opis.Set((using"%s%d",prefix,poz.lp),GetName(mzb))
			if ((firma.code == "HM") || (firma.code == "HL")) then
				SetKeySeg(uz,"iduz",GetField(mzb,"idtw"))
				SetKeySeg(uz,"idkh",GetField(mzb,"idkh"))
				if !GetRec(uz,EQ) then poz.KodObcy=GetField(uz,"kodobcy")
			endif
			poz.Kod=GetField(mzb,"kod")
			poz.Jm=GetField(mzb,"jm")	
			poz.JmWP=GetField(mzb,"jmWP")	
		poz.idtw = GetField (mzb,"idtw" )
		endif
		
//		if KorektaCeny(size(KorektaCeny)).id then grow KorektaCeny,1
//		j=size(KorektaCeny)

//		KorektaCeny(j).Cena=GetField(mzb,"cena")
//		KorektaCeny(j).lp=poz.lp
		// ustalenie dostawy pozycji z pierwszej PZ-ki
//		SetKeySeg(mz2,"lp",GetField(mzb,"lp"))
//		SetKeySeg(mz2,"super",-1*GetField(mgb,"iddokkoryg"))
//		if !GetRec(mz2,EQ) then
//			SetKeySeg(pw,"typ","37")
//			SetKeySeg(pw,"idmg",GetField(mz2,"id"))
//			SetKeySeg(pw,"iddw",0)
//			if !GetRec(pw,GE) && GetField(pw,"typ")=="37" && GetField(pw,"idmg")==GetField(mz2,"id") then
//				SetKeySeg(dw,"id",GetField(pw,"iddw"))
//				if !GetRec(dw,EQ) then KorektaCeny(j).id=GetField(dw,"id")//Dostawy(nDostawy).nazwa = GetField(dw,"kod") : Dostawy(nDostawy).id=GetField(dw,"id")
//			endif
//		else
//			if nDostawy>1 && Dostawy(nDostawy).typ==2 && Dostawy(nDostawy).lp==KorektaCeny(j).lp then //Dostawy(nDostawy-1).typ==Dostawy(nDostawy).typ && Dostawy(nDostawy-1).lp==Dostawy(nDostawy).lp then
//				KorektaCeny(j).id=Dostawy(nDostawy).id
//			endif
//		endif
	endif
endsub

int sub UstalIlosc_i_Dostawy(infopoz poz, int idpoz, int iddost)
	if Dostawy(iddost).ilosc!=0 && dostawy(iddost).cena==0 then Dostawy(iddost).Ilosc=dostawy(iddost).ilosc/PozycjeKOryg(idpoz).PrzelJMDod 
endsub


// ***********************************

iddok = Val ( Arg1 )
if !iddok then message "Raport mona wykona tylko z okna dokumentu" : Error ""
GRAF = !Val ( Arg0 )
BUFOR = Val ( Arg2 )

if arg9 then
	sNapis = arg9
else
	select case Val ( Arg3 )
		case 0
			sNapis = "ORYGINA"
		case 1
			sNapis = "KOPIA"
		case 2
			sNapis = "ORYGINA/KOPIA"
		case 4
			sNapis = "DUPLIKAT"
	endselect
endif

sMG = "mg"
sMZ = "mz"
sDK = "dk"
sDP = "dp"
if BUFOR then sMG="bm" : sMZ="bz" : sDK="bd" : sDP="bp"

mgb = OpenBase(sMG)
mzb = OpenBase(sMZ)
mg = OpenBase("mg")
mz = OpenBase("mz")
nt = OpenBase("nt")
pw = OpenBase("pw")
dw = OpenBase("dw")
zz = OpenBase("zz")
kh = OpenBase("kh")
uz = OpenBase("uz")
tw = OpenBase("tw")
dppom = OpenBase("dp")

SetKey( uz, "kodnasz")
SetKeySeg(uz,"typi",32)

SetKey ( mgb,"id" )
SetKeySeg( mgb,"id",iddok )
if GetRec( mgb,EQ ) then BaseError ( mgb,4 )
SetKey ( mg,"id" )
SetKey(zz,"id")

SetKey(mz,"super")
SetKey(pw,"dostawy")
SetKey( dw,"id" )


if GetField(mgb,"idhandl") then
	dk = OpenBase(sDK)
	SetKey(dk,"id")
	SetKeySeg(dk,"id",GetField(mgb,"idhandl"))
	if !GetRec(dk,EQ) then
		sKodDokHand = GetField(dk,"kod")
		sDataDokHand = GetField(dk,"data")		
	endif
	close dk
endif


// zbieranie dokumentu korygujcego
mz2 = OpenBase("mz")
SetKey(mz2,"super")
SetKey(mzb,"super")
SetKeySeg(mzb,"super",iddok)
SetKeySeg(mzb,"lp",0)
err = GetRec(mzb,GE)
while !err && GetField(mzb,"super")==iddok
	buf="37"
	if BUFOR then buf = "39"
	if GetField(mzb,"typi")&0x10 then
		// wyrwnanie pozycji
		j=0
		for i=1 to i>nPoz
			if PozycjeKoryg(i).lp == GetField(mzb,"lp") then j=i : i=nPoz+1
		next i
		if j then
			ZbierzPozycje(PozycjeKoryg(j),mzb,2,val(buf),"K")
		else
//			Message "Brak pozycji do pozycji wyrwnujcej"
		endif
	else
		if nPoz then grow PozycjeKoryg,1 : grow PozycjePoKor,1
		nPoz+=1
		ZbierzPozycje(PozycjeKoryg(nPoz),mzb,2,val(buf),"K")
		if BUFOR && GetField(mzb,"rezerwacja") then ZbierzRezerwacje(PozycjeKoryg(nPoz),mzb,2,"K")
		ZbierzKorekteCeny(PozycjeKoryg(nPoz),2,"K")
		tot_netto+=PozycjeKoryg(nPoz).wartosc
		// dodanie pozycji po korekcie
		PozycjePoKor(nPoz).lp=PozycjeKoryg(nPoz).lp
		PozycjePoKOr(nPoz).PrzelJMDod=PozycjeKoryg(nPoz).PrzelJMDod
		PozycjePoKor(nPoz).Opis=PozycjeKoryg(nPoz).Opis
		PozycjePoKor(nPoz).KodObcy=PozycjeKoryg(nPoz).KodObcy
		PozycjePoKor(nPoz).Kod=PozycjeKoryg(nPoz).Kod
		PozycjePoKor(nPoz).Jm=PozycjeKoryg(nPoz).Jm	
		PozycjePoKor(nPoz).JmWP=PozycjeKoryg(nPoz).JmWP	
		PozycjePoKor(nPoz).idtw = PozycjeKoryg(nPoz).idtw
	endif

	err = GetRec(mzb,NX)
wend
close mz2

// tworzenie dokumentu przed korekt

if GetField(mgb,"iddokkoryg")>0 then
	// zwyka korekta wydania z magazynu
	SetKeySeg(mg,"id",GetField(mgb,"iddokkoryg"))
	grow PozycjeBaza,nPoz-1
	do
		if GetRec(mg,EQ) then Error "Brak dokumentu korygowanego lub ktrej z jego korekt w bazie dokumentw magazynowych"
		if KodyKorekt(1) then grow KodyKorekt,1
		KodyKorekt(size(KodyKorekt))=GetField(mg,"kod")+" "+GetField(mg,"data")
		SetKeySeg(mz,"super",GetField(mg,"id"))
		SetKeySeg(mz,"lp",0)
		err=GetRec(mz,GE)
		while !err && GetField(mz,"super")==GetField(mg,"id")
			for k=1 to k>nPoz
				if PozycjeKoryg(k).lp == GetField(mz,"lp") then
					ZbierzPozycje(PozycjeBaza(k),mz,1,37,"B")
					k=nPoz	// koniec szukania
				endif
			next k
			err=GetRec(mz,NX)
		wend
		SetKeySeg( mg,"id",GetField(mg,"idkorekt"))
	loop while GetKeySeg(mg,"id")!=iddok && (!BUFOR || GetField(mg,"idkorekt"))
else
	// korekta kilku wyda (lub przyj na raz)
	dk=OpenBase("dk")
	dp=OpenBase("dp")
	SetKey(dp,"super")
	mg2 = OpenBase("mg")
	mz2 = OpenBase("mz")
	SetKey(mg2,"idhandl")
	SetKey(mz2,"idhandl")

	IdNaIndex.Type(int)
	grow PozycjeBaza,nPoz-1
	for i=1 to i>nPoz
		PozycjeBaza(i).lp=PozycjeKoryg(i).lp
	next i
	// po kolejnych dokumentach handlowych
	SetKey(dk,"id")
	SetKeySeg(dk,"id",-GetField(mgb,"iddokkoryg"))
	if GetRec(dk,EQ) then error "Nie znaleziono dokumentu handlowego skojarzonego z korekt zbiorcz"
	err=0
	do
		// dla kadego przegldamy dokumeny magazynowe z nim skojarzone
		// i gdy id<iddok to dodajemy jego zawarto

		// tworzymy map id-w pozycji, do ktrych mamy korekty (id)->index w tablicy pozycji korygowanych
		lTemp=GetField(dk,"id")

		IdNaIndex.Clear()
		SetKeySeg(dp,"super",lTemp)
		SetKeySeg(dp,"lp",0)
		err=GetRec(dp,GE)
		while !err && GetField(dp,"super")==lTemp
			for i=1 to i>nPoz
				if PozycjeKoryg(i).lp == GetField(dp,"lp") then	IdNaIndex.Set((using "%d",GetField(dp,"id")),i)
			next i
			err=GetRec(dp,NX)
		wend

		SetKeySeg(mg2,"idhandl",lTemp)
		SetKeySeg(mg2,"data","")
		err=GetRec(mg2,GE)
		while !err && ( GetField(mg2,"idhandl")==lTemp || GetField(mg2,"idhandl")== -lTemp )
			if GetField(mg2,"id")<iddok || BUFOR then
				// dodanie tego dokumentu do wartoci sprzed korekty
				// kolejno po pozycjach tego dokumentu

				if KodyKorekt(1) then grow KodyKorekt,1
				KodyKorekt(size(KodyKorekt))=GetField(mg2,"kod")+" "+GetField(mg2,"data")

				SetKeySeg(mz,"super",GetField(mg2,"id"))
				SetKeySeg(mz,"lp",0)
				err=GetRec(mz,GE)
				while !err && GetField(mz,"super")==GetField(mg2,"id")
					if IdNaIndex.Index(using "%d",GetField(mz,"idhandl")) then
						// ta pozycja rozlicza pozycj korygowan
						i = IdNaIndex.Get(using "%d",GetField(mz,"idhandl"))
						if PozycjeBaza(i).Lp then 
						bazaLp=PozycjeBaza(i).Lp
						else
						bazaLP=GetField(mz,"lp")
						endif	
						if !PozycjeBaza(i).kod then
							PozycjeBaza(i).Opis=GetField(mz,"opis")
							bNP=0
							if czyNPinna then
								if iddp=GetField(mz,"idhandl") then
									SetKey(dppom,"id")
									SetKeySeg(dppom,"id",iddp)
									if !GetRec(dppom,EQ) then
										if GetField(dppom,"stvati")==255 then
											licznikNP+=1
											bNP=1
											NPpraw(licznikNP)=GetField(mz,"lp")
											grow NPpraw,1
										endif
									endif
								endif
							endif
								
							if poz_opis.Index((using"B%d",IIF(bNP,NPinna(licznikNP),bazaLp))) then
								poz_opis.Set((using"B%d",bazaLp),GetName(mz))
							else
								poz_opis.Set((using"B%d",IIF(bNP,NPinna(licznikNP),bazaLp)),GetName(mz))
							endif
							if ((firma.code == "HM") || (firma.code == "HL")) then
								SetKeySeg(uz,"iduz",GetField(mz,"idtw"))
								SetKeySeg(uz,"idkh",GetField(mz,"idkh"))
								if !GetRec(uz,EQ) then PozycjeBaza(i).KodObcy=GetField(uz,"kodobcy")
							endif
							PozycjeBaza(i).Kod = GetField(mz,"kod")
							PozycjeBaza(i).Jm = GetField(mz,"jm")	
							PozycjeBaza(i).JmWP = GetField(mz,"jmWP")	
						endif
						ZbierzPozycje(PozycjeBaza(IdNaIndex.Get(using "%d",GetField(mz,"idhandl"))),mz,1,37,"B")
					endif
					err=GetRec(mz,NX)
				wend

			endif
			err=GetRec(mg2,NX)
		wend

		// cena jest rednia ze wszystkich
		for i=1 to i>nPoz
			if Sign(PozycjeBaza(i).ilosc,4) then
				PozycjeBaza(i).Cena=PozycjeBaza(i).Wartosc/PozycjeBaza(i).ilosc
				PozycjeBaza(i).CenaWP=PozycjeBaza(i).Wartosc/PozycjeBaza(i).iloscWP
			endif
		next i	
	grow PozycjeBaza,nPoz-1


		lTemp=GetField(dk,"idkorekt")
		if lTemp then
			SetKeySeg(dk,"id",lTemp) : err=GetRec(dk,EQ)
			if err then message using "Brak dokumentu handlowego id=%s w acuchu korekt",lTemp
		endif
	loop while ltemp
	close dk
	close dp
	close mg2
	close mz2
endif
if poz_opis.size()<2*size(PozycjeKoryg) then
	j=1
	err=poz_opis.Size()
	For i=size(PozycjeKoryg)+1 to i>err
	buf=poz_opis.GetKey(size(PozycjeKoryg)+1)
	poz_opis_Tmp.Set(buf,poz_opis.Get(size(PozycjeKoryg)+1))
	poz_opis.Del(buf)
	Next i
	For i=1 to i>size(PozycjeKoryg)
	buf=poz_opis.GetKey(i)
	buf="B"+mid(buf,2)
	if !poz_opis_Tmp.Index(buf) then
		poz_opis.Set(buf,poz_opis.Get(i))
		if !sign(PozycjeBaza(i).Ilosc,6) then
		PozycjeBaza(i)=PozycjeKoryg(i)
		PozycjeBaza(i).Ilosc=0
		PozycjeBaza(i).IloscWP=0
		PozycjeBaza(i).Wartosc=0
		PozycjeKoryg(i).Cena=0
		PozycjeKoryg(i).CenaWP=0
	endif
	else
		poz_opis.Set(poz_opis_Tmp.GetKey(j),poz_opis_Tmp.Get(j))
		j+=1
	endif
	next i
endif

// uzupenienie tych pozycji dostaw, ktre s korekt ceny
for i=1 to i>nDostawy
	if Dostawy(i).typ==2 && !Sign(Dostawy(i).ilosc,4) && !Sign(Dostawy(i).wartosc) then
		for j=1 to j>size(PozycjeBaza)
			if Dostawy(i).lp == PozycjeBaza(j).lp then Dostawy(i).wartosc = ((PozycjeBaza(j).ilosc+PozycjeKoryg(j).ilosc)*Dostawy(i).Cena)
		next j
	endif
next i


SetKeySeg(mgb,"id",iddok)
GetRec(mgb,EQ)
sNazwaDok = GetField( mgb, "nazwa" )
sDataWyst = GetField( mgb,"datasp" )
sNumerDok = GetField( mgb,"kod" )
string sDataSp = GetField( mgb,"data" )
string sNabywca = GetField( mgb,"khnazwa" )
string sNabKodPocz = GetField( mgb,"khkodpocz" )
string sNabMiasto = GetField( mgb,"khmiasto" )
string sNabAdres = BuildAdresKh( mgb)
string sNabNip = GetField( mgb,"khnip" )
string sNabKod = GetField( mgb,"khkod" )
string sNabTel1,sNabTel2,sNabFax,sNabEmail
SetKey(kh,"id")
SetKeySeg(kh,"id",GetField(mgb,"khid"))
if !GetRec(kh,EQ) then
	sNabTel1=GetField(kh,"tel1")
	sNabTel2=GetField(kh,"tel2")
	sNabFax=GetField(kh,"fax")
	sNabEMail=GetField(kh,"email")
endif
int 	 nMagazyn = GetField(mgb, "magazyn")
string sOpis = GetField( mgb,"opis" )
int bAnulowano
if GetField( mgb,"subtypi" ) == 0 || GetField( mgb,"subtypi" ) == 1 then bAnulowano = 1

SetKey ( nt,"super" )
SetKeySeg( nt,"typi",0 )
SetKeySeg( nt,"baza",33 )
if BUFOR then SetKeySeg( nt,"baza",38 )
SetKeySeg( nt,"super",iddok )
string sNotatka
if !GetRec( nt,EQ ) then
	Arg "\r",""
	buf = GetField( nt,"opis" )
	replace arg
	sNotatka = buf
endif

firma.Magazyn(nMagazyn)
if !firma.Uzywaj then firma.Magazyn(0)
// wyznaczenie po korekcie
for i=1 to i>nPoz
	if PozycjeBaza(i).Ilosc then PozycjeBaza(i).cena=PozycjeBaza(i).wartosc/PozycjeBaza(i).ilosc
	PozycjeKoryg(i).PrzelJmDod=PozycjeBaza(i).PrzelJmDod
	if Sign(PozycjeBaza(i).IloscWP+PozycjeKoryg(i).IloscWP,4) then PozycjeKoryg(i).PrzelJmDod=(PozycjeBaza(i).Ilosc+PozycjeKoryg(i).Ilosc)/(PozycjeBaza(i).IloscWP+PozycjeKOryg(i).IloscWP)
	if !PozycjeKOryg(i).PrzelJmDod then PozycjeKOryg(i).PrzelJmDod=1
	if PozycjeBaza(i).IloscWP then PozycjeBaza(i).cenaWP=PozycjeBaza(i).wartosc/PozycjeBaza(i).iloscWP
	nWskZer=(PozycjeBaza(i).Ilosc==0 && PozycjeBaza(i).Cena==0)
	PozycjeKoryg(i).Cena=((PozycjeBaza(i).CenaWP+PozycjeKoryg(i).CenaWP)/PozycjeKoryg(i).PrzelJmDod)-IIF(nWskZer,0,PozycjeBaza(i).CenaWP/PozycjeBaza(i).PrzelJMDod)
	PozycjePoKor(i).ilosc=PozycjeBaza(i).ilosc+PozycjeKoryg(i).ilosc
	PozycjePoKor(i).iloscWP= PozycjeKoryg(i).iloscWP + PozycjeBaza(i).iloscWP
	PozycjePoKor(i).wartosc=PozycjeBaza(i).wartosc+PozycjeKoryg(i).wartosc
	PozycjePoKor(i).cena=PozycjeBaza(i).Cena+PozycjeKoryg(i).Cena//iif(PozycjePoKor(i).ilosc!=0,PozycjePoKor(i).wartosc/PozycjePoKor(i).ilosc,PozycjeBaza(i).cena)
	PozycjePoKor(i).cenaWP=PozycjeBaza(i).CenaWP+PozycjeKoryg(i).CenaWP//iif(PozycjePoKor(i).iloscWP!=0,PozycjePoKor(i).wartosc/PozycjePoKor(i).iloscWP,PozycjeBaza(i).cenaWP)
//	PozycjeKoryg(i).iloscWP = PozycjeKoryg(i).ilosc * iif((PozycjeBaza(i).ilosc + PozycjeKoryg(i).ilosc)!=0,((PozycjeBaza(i).iloscWP + PozycjeKoryg(i).iloscWP)/(PozycjeBaza(i).ilosc + PozycjeKoryg(i).ilosc)),1)
//	if PozycjeKoryg(i).IloscWP then PozycjeKoryg(i).PrzelJMDod=PozycjeKoryg(i).Ilosc/PozycjeKoryg(i).IloscWP
//	if !PozycjeKoryg(i).Ilosc && !PozycjeKoryg(i).IloscWP then PozycjeKoryg(i).PrzelJMDod=PozycjeBaza(i).PrzelJMDod	
//	PozycjePoKor(i).PrzelJMDod=PozycjeKoryg(i).PrzelJMDod
//	if PozycjePoKor(i).PrzelJMDod==1 then
//		if PozycjePoKOr(i).Ilosc then PozycjePoKor(i).Cena=PozycjePoKor(i).Wartosc/PozycjePoKor(i).Ilosc
//		if PozycjePoKOr(i).IloscWP then PozycjePoKor(i).CenaWP=PozycjePoKor(i).Wartosc/PozycjePoKor(i).IloscWP
//	endif
	tot_nettoPrzed+=PozycjeBaza(i).wartosc
	tot_nettoPo+=PozycjePoKor(i).wartosc
next i
int tabpom(1)
grow tabpom,nDostawy-1
for i=1 to i>nDostawy
	tabpom(i)=1
next i

for i=1 to i > size(PozycjeKOryg)
	for j=1 to j >size(Dostawy)
		if Dostawy(j).lp==PozycjeKoryg(i).lp && Dostawy(j).typ==2 then
			Dostawy(j).Cena=PozycjeKoryg(i).Cena/PozycjeKoryg(i).PrzelJMDod
		endif
	next j
next i

l=nDostawy
for j=1 to j>nDostawy
	if tabpom(j) then
		tabpom(j)=0
		l+=1
		grow Dostawy,1
		dostawy(l).lp=Dostawy(j).lp
		dostawy(l).id=Dostawy(j).id
		dostawy(l).typ=3
		dostawy(l).nazwa=Dostawy(j).nazwa
		//dostawy(l).cena=Dostawy(j).cena
		dostawy(l).ilosc=Dostawy(j).ilosc
		dostawy(l).wartosc=Dostawy(j).wartosc
		for k=j+1 to k>nDostawy
			if tabpom(k) && dostawy(k).lp==dostawy(j).lp && dostawy(k).id==dostawy(l).id then
				tabpom(k)=0
//				if (Dostawy(j).cena == 0 && k==j+1) || k>j+1 || nDostawy==2 then dostawy(l).cena+=dostawy(k).cena
				if (Dostawy(j).ilosc == 0 && k==j+1) || k>j+1 || nDostawy==2 then dostawy(l).ilosc+=dostawy(k).ilosc
				if (Dostawy(j).wartosc==0 && k==j+1) || k > j+1 || nDostawy==2 then dostawy(l).wartosc+=dostawy(k).wartosc
			endif
		next k
		if Sign(dostawy(l).ilosc,4) then dostawy(l).cena = dostawy(l).wartosc / dostawy(l).ilosc
		if !(Dostawy(l).Ilosc+Dostawy(l).wartosc+Dostawy(l).Cena) && !Dostawy(l).nazwa then shrink Dostawy, 1 : l-=1//!Sign(dostawy(l).ilosc,4) then l-=1 : shrink dostawy,1
	endif
next j
nDostawy=l

// wczytanie korekt wartoci magazynowych KWM
SetKey(mgb,"idhandl")
SetKeySeg(mgb,"idhandl",-iddok)
SetKeySeg(mgb,"data","")
err=GetRec(mgb,GE)
while !err && GetField(mgb,"idhandl")==-iddok
	if korektyWM(1).kod then grow korektyWM,1
	korektyWM(size(korektyWM)).kod=GetField(mgb,"kod")
	korektyWM(size(korektyWM)).przychod=GetField(mgb,"przychod")
	korektyWM(size(korektyWM)).rozchod=GetField(mgb,"rozchod")
	tot_KWMprzy += GetField(mgb,"przychod")
	tot_KWMroz	+= GetField(mgb,"rozchod")
	err=GetRec(mgb,NX)
wend
tot_KWM	= tot_KWMprzy + tot_KWMroz
