//"nt2bt.sc","Zmiana kontraktu z netto na brutto",12301,0,2.1.0,SYSTEM
//"Sprzeda",12002,14,16


////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
int sub ZmienNaBrutto(long lId)

	int iDk = open KatalogFirmy() + "51BD.dat" for base "BD"
	
	int nRet = 0
	
	SetKey(iDk, "id")
	SetKeySeg(iDk, "id", lId)
	
	nRet = GetRec(iDk, EQ)
	
	if nRet then error using "Bd odczytu rekordu nr %d z bazy DK.", nRet
	
	if GetField(iDk, "subtypi") != 109 || GetField(iDk, "typi") != 1 then
		message "Wybrany dokument nie jest wystawionym kontraktem."
		error ""
	endif

	int iNetto = GetField(iDk, "grupaceni")
	
	if (iNetto & 0x01) == 0 then
		message using "Kontrakt o numerze '%s' jest ju wystawiony od brutto.", GetField(iDk, "kod")
		error ""
	endif
	
	iNetto = iNetto & ~0x01
	
	SetField(iDk, "grupaceni", iNetto)
	
	nRet = PutRec(iDk)
	
	if nRet then error using "Bd aktualizacji rekordu nr %d z bazy DK.", nRet
	
	int iDp = open KatalogFirmy() + "51BP.dat" for base "BP"
	
	SetKey(iDp, "super")
	SetKeySeg(iDp, "super", lId)
	
	nRet = GetRec(iDp, GE)
	
	float dCena = 0

	float dTmp
	while nRet == 0 && GetField(iDp, "super") == lId
		SetField(iDp, "grupaceni", GetField(iDp, "grupaceni") & ~0x01)

		dCena = GetField(iDp, "wartNetto") + GetField(iDp, "wartVat")
		dCena = dCena / GetField(iDp, "iloscwp")
		SetField(iDp, "cena", dCena)

		dCena = GetField(iDp, "cenaBazaPl")
		dTmp = GetField(iDp, "wartstvat")
		dTmp = dTmp / 10000
		dTmp = dTmp + 1
		dCena = dCena * dTmp
		SetField(iDp, "cenaBazaPl", dCena)

	
		nRet = PutRec(iDp)
	
		nRet = GetRec(iDp, NX)
	wend

	message using "Zmiana w kontrakcie '%s' zostaa dokonana.", GetField(iDk, "kod")
	
	close(iDp)
	close(iDk)

	ZmienNaBrutto = 0
endsub
////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////


//////////////// main //////////////////////////////////////

int err = SetTaggedPos(FS)

if err == 0 then 
	message "Nie wybrano adnego kontraktu."
	error ""
endif

long lId = GetLineId()

err = SetTaggedPos(NX)

if err != 0 then 
	message "Naley wybra tylko jeden kontrakt."
	error ""
endif


err = ZmienNaBrutto(lId)

if err != 0 then error using "Bd numer %d, operacja nie powioda si.", err

error ""

